/**
* DBManagerWR.java
* @Autore: Cesare Gerbino
* @Data creazione: 26/12/2001
* @Versione: 1.0
*
* Classe che implementa la ricerca.
* Si occupa di caricare i driver opportuni, stabilire la connessione, e creare lo statement.
* Restituisce il risultato della query sotto forma di una tabella HTML nella pagina di risposta.
* Si occupa di fare un update sul DB nel momentoin cui  necessario inserire un nuovo
* elemento
*
*/

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class DBManagerWR
 {
  Statement st;
  ServletOutputStream out;
  Connection con;
  
  public DBManagerWR()
   {
    try
     {
      System.out.println("Inzializzazione DBManager ....");
      System.out.println("Caricamento driver ...");
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      System.out.println("Driver caricato ...");
      System.out.println("Conessione al data base ...");
      con = DriverManager.getConnection("jdbc:odbc:DBServletWR");
      System.out.println("Connessione instaurata ...");
      System.out.println("Creazione statement ...");
      st = con.createStatement();
      System.out.println("Statement creato ...");
      System.out.println("DBManager pronto ...");	
     }
    catch (SQLException sqle)
     {
      System.out.println("Attenzione errore  sql "+sqle.getMessage()+"\n");      	
     }
    catch (ClassNotFoundException cnfe)
     {
      System.out.println("Attenzione classe non trovata "+cnfe.getMessage()+"\n");      	
     }
    catch (Exception e)
     {
      System.out.println("Attenzione eccezione "+e.getMessage()+"\n");      	
     }     
   } 	
   
  public void executeQuery(String SqlString) throws IOException
   {
    try
     {
      System.out.println(SqlString);
      ResultSet rs = st.executeQuery(SqlString);
      out.println("<HEAD>");
      out.println(" <TITLE>");
      out.println("  Pagina generata dalla servlet DBServlet - QUERY");
      out.println(" </TITLE>");
      out.println("</HEAD>");
      out.println("<BODY>");
      out.println(" Output della query");
      out.println(" <BR>");
      out.println(" <BR>");
      out.println(" <TABLE border=1>");
      out.println("  <TR>");
      ResultSetMetaData rsmtd = rs.getMetaData();
      for (int i = 1; i <= rsmtd.getColumnCount(); i++)
       {
        out.println("   <TD>");
        out.println("    " + rsmtd.getColumnName(i));
        out.println("   </TD>");
       }
      out.println("  </TR>");
      while (rs.next())
       {
        out.println("  <TR>");       	
        for (int i = 1; i <= rsmtd.getColumnCount(); i++)
         {
          out.println("   <TD>");
          out.println("    " + rs.getString(i));
          out.println("   </TD>");
         }
        out.println("  </TR>");       	
       }
      out.println(" </TABLE>");
      out.println("</BODY>");
     }
    catch (SQLException	sqle)
     {
      System.out.println("Errore " + sqle.getMessage());	
     }    
   }

  public void executeUpdate(String SqlString) throws IOException
   {
    try
     {
      System.out.println(SqlString);
      st.executeUpdate(SqlString);
      out.println("<HEAD>");
      out.println(" <TITLE>");
      out.println("  Pagina generata dalla servlet DBServlet - UPDATE");
      out.println(" </TITLE>");
      out.println("</HEAD>");
      out.println("<BODY>");
      out.println(" <B>Update avvenuto !!!</B>");
      out.println("</BODY>");
     }
    catch (SQLException	sqle)
     {
      System.out.println("Errore " + sqle.getMessage());	
     }    
   }

  public void setOutput(ServletOutputStream o) 
   {
    out = o;
   }

  public void closeConnection() 
   {
    st = null;
    try 
     {
      con.close();     	
     }
    catch (SQLException e)
     {
      System.out.println("Problemi in chiusura connessione: " + e.getMessage());
     }
   }
 }
